Getting Started with PasswordTextBox Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the PasswordTextBox module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.passwordtextbox.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-password-text-box id="passwordtextbox"></smart-password-text-box>

    Host container (id matches appendTo on Smart.PasswordTextBox):

    <div id="passwordtextboxContainer"></div>

  5. Initialize after the module loads: define a const passwordtextboxOptions object, then either bind with Smart('#passwordtextbox', ...) on the semantic tag or use new Smart.PasswordTextBox({ ...passwordtextboxOptions, appendTo: '#passwordtextboxContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.passwordtextbox.js';
    
    	const passwordtextboxOptions = { disabled: true };
    
    	// Option A - semantic <smart-password-text-box> with id="passwordtextbox"
    	Smart('#passwordtextbox', class {
    		get properties() {
    			return passwordtextboxOptions;
    		}
    	});
    
    	// Option B - host div id="passwordtextboxContainer"
    	// const passwordtextboxInstance = new Smart.PasswordTextBox({
    	// 	...passwordtextboxOptions,
    	// 	appendTo: '#passwordtextboxContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const myPasswordTextBox = new Smart.PasswordTextBox('#passwordtextbox', passwordtextboxOptions);
    	// document.body.appendChild(myPasswordTextBox);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.PasswordTextBox('#passwordtextbox', passwordtextboxOptions) with appendChild, and document.createElement('smart-password-text-box') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.PasswordTextBox({ ...options, appendTo: '#...' }); new Smart.PasswordTextBox('#passwordtextbox', passwordtextboxOptions) plus appendChild on the returned element; and document.createElement('smart-password-text-box') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const myPasswordTextBox = new Smart.PasswordTextBox('#passwordtextbox', passwordtextboxOptions)):

	const passwordtextboxOptions = { disabled: true };
	const myPasswordTextBox = new Smart.PasswordTextBox('#passwordtextbox', passwordtextboxOptions);
	document.body.appendChild(myPasswordTextBox);
	

Create with document.createElement('smart-password-text-box'), assign properties (same as any custom element), then append:

	const passwordtextboxOptions = { disabled: true };
	const passwordtextbox = document.createElement('smart-password-text-box');
	Object.assign(passwordtextbox, passwordtextboxOptions);
	document.body.appendChild(passwordtextbox);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.passwordtextbox.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const passwordtextboxOptions = { disabled: true };
		const passwordtextbox = new Smart.PasswordTextBox({
			...passwordtextboxOptions,
			appendTo: '#passwordtextboxContainer'
		});
	}
	

Append to the DOM:

const container = document.getElementById('passwordtextbox-container');
container.appendChild(passwordtextbox);
	

Remove from the DOM:

passwordtextbox.remove();
	

Set a property:

passwordtextbox.disabled = true;
passwordtextbox.theme = 'dark';
	

Get a property value:

const isDisabled = passwordtextbox.disabled;
const currentTheme = passwordtextbox.theme;
	

Invoke a method:

passwordtextbox.refresh();
passwordtextbox.focus();
	

Add event listener:

passwordtextbox.addEventListener('change', (event) => {
    console.log('change triggered:', event.detail.oldValue);
});
	

Remove event listener:

const handlePasswordTextBoxEvent = (event) => {
    console.log('change triggered:', event.detail.oldValue);
};

passwordtextbox.addEventListener('change', handlePasswordTextBoxEvent);
passwordtextbox.removeEventListener('change', handlePasswordTextBoxEvent);
	

Accessibility

The PasswordTextBox component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular PasswordTextBox - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/passwordtextbox/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import PasswordTextBoxModule from smart-webcomponents-angular/passwordtextbox: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { PasswordTextBoxModule } from 'smart-webcomponents-angular/passwordtextbox';

4 Root component (standalone)

Add PasswordTextBoxModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { PasswordTextBoxComponent } from 'smart-webcomponents-angular/passwordtextbox';

import { PasswordTextBoxModule } from 'smart-webcomponents-angular/passwordtextbox';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ PasswordTextBoxModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('passwordtextbox', { read: PasswordTextBoxComponent, static: false }) passwordtextbox!: PasswordTextBoxComponent;
	
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-password-text-box as needed:

 <div class="demo-description">Simple password field.</div>
<smart-password-text-box #passwordtextbox [placeholder]="'Your password'"></smart-password-text-box>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put PasswordTextBoxModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put PasswordTextBoxModule from smart-webcomponents-angular/passwordtextbox on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { PasswordTextBoxModule } from 'smart-webcomponents-angular/passwordtextbox';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, PasswordTextBoxModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The PasswordTextBox component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React PasswordTextBox Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/passwordtextbox/basic/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from "react";
import { PasswordTextBox } from 'smart-webcomponents-react/passwordtextbox';

const App = () => {
    // Equivalent of componentDidMount
    // React.useEffect(() => {
    //     // Any side-effects here
    // }, []);

    return (
        <div>
            <div className="demo-description">Simple password field.</div>
            <PasswordTextBox placeholder="Your password"></PasswordTextBox>
        </div>
    );
};

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { PasswordTextBox, PasswordTextBoxProps } from 'smart-webcomponents-react/passwordtextbox';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The PasswordTextBox component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.